%define momorel 4
%define src0_md5sum 978847992b136c8d8cb5c6559a91df1c

Summary: Tool for finding memory management bugs in programs
Name: valgrind
Version: 3.2.3
Release: %{momorel}m%{?dist}
License: GPL
Group: Development/Debuggers
URL: http://www.valgrind.org/
%NoSource 0 http://www.valgrind.org/downloads/%{name}-%{version}.tar.bz2 %{src0_md5sum}
Patch1: valgrind-3.2.3-openat.patch
Patch2: valgrind-3.2.3-cachegrind-improvements.patch
Patch3: valgrind-3.2.3-pkg-config.patch
Patch5: valgrind-3.2.3-io_destroy.patch

Patch1000: valgrind-3.2.3-glibc26-workaround.patch

### include local configuration
%{?include_specopt}

### default configurations
#  If you'd like to change these configurations, please copy them to
# ~/rpm/specopt/valgrind.specopt and edit it.
%{?!do_test: %global do_test 1}
#
# include_specopt is written after Name tag

BuildRoot: %{_tmppath}/%{name}-%{version}-root/
%ifarch x86_64 ppc64
# Ensure glibc{,-devel} is installed for both multilib arches
BuildRequires: /lib/libc.so.6 /usr/lib/libc.so /lib64/libc.so.6 /usr/lib64/libc.so
%endif
BuildRequires: glibc-devel >= 2.5
ExclusiveArch: %{ix86} x86_64 ppc ppc64
# for Patch1000
BuildRequires: autoconf automake19

## Disable build root strip policy
#%%define __spec_install_post /usr/lib/rpm/brp-compress || :

%description 
Valgrind is a tool to help you find memory-management problems in your
programs. When a program is run under Valgrind's supervision, all
reads and writes of memory are checked, and calls to
malloc/new/free/delete are intercepted. As a result, Valgrind can
detect a lot of problems that are otherwise very hard to
find/diagnose.

%prep

print_specopt() {
## echo the specopt values
cat <<EOF
Configurations:
  do_test ............ %{do_test}
EOF
}
print_specopt
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch5 -p1

%patch1000 -p1 -b .glibc26-hack~

autoconf
automake-1.9
aclocal-1.9

%build
%ifarch x86_64 ppc64
# Ugly hack - libgcc 32-bit package might not be installed
mkdir -p libgcc/32
touch libgcc/32/libgcc_s.a
touch libgcc/libgcc_s_32.a
%configure CC="gcc -B `pwd`/libgcc/" GDB=%{_bindir}/gdb
%else
%configure GDB=%{_bindir}/gdb
%endif

# Force a specific set of default suppressions
echo -n > default.supp
for file in glibc-2.6.supp ; do
    cat $file >> default.supp
done

%make

# Ensure there are no unexpected file descriptors open,
# the testsuite otherwise fails.
cat > close_fds.c <<EOF
#include <stdlib.h>
#include <unistd.h>
int main (int argc, char *const argv[])
{
  int i, j = sysconf (_SC_OPEN_MAX);
  if (j < 0)
    exit (1);
  for (i = 3; i < j; ++i)
    close (i);
  execvp (argv[1], argv + 1);
  exit (1);
}
EOF
gcc $RPM_OPT_FLAGS -o close_fds close_fds.c

for i in `find . -type f \( -name *-amd64-linux -o -name *-x86-linux -o -name *-ppc*-linux \)`; do
  case "`file $i`" in
    *ELF*executable*statically\ linked*)
      objcopy -R .debug_loc -R .debug_frame -R .debug_ranges $i
  esac
done

# test
%if %{do_test}
%check
make check || :
echo ===============TESTING===================
./close_fds make regtest || :
echo ===============END TESTING===============
%endif 

%install
rm -rf %{buildroot}
%makeinstall

mkdir docs.installed
mv %{buildroot}%{_datadir}/doc/valgrind/* docs.installed/
rm -f docs.installed/*.ps

%ifarch x86_64
rm -rf %{buildroot}%{_libdir}/valgrind/x86-linux
ln -sf ../../lib/valgrind/x86-linux %{buildroot}%{_libdir}/valgrind/x86-linux
%endif

%ifarch ppc64
rm -rf %{buildroot}%{_libdir}/valgrind/ppc32-linux
ln -sf ../../lib/valgrind/ppc32-linux %{buildroot}%{_libdir}/valgrind/ppc32-linux
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc ACKNOWLEDGEMENTS COPYING NEWS README_*
%doc docs.installed/html docs.installed/*.pdf
%{_bindir}/*
%{_includedir}/valgrind
%{_libdir}/valgrind
%{_libdir}/pkgconfig/*
%{_mandir}/man1/valgrind*

%changelog
* Wed Jul  4 2007 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.3-4m)
- move %%check place for configure option %%do_test

* Sat Jun 30 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.2.3-3m)
- sync with fc-devel (valgrind-3_2_3-4)
-- add valgrind-3.2.3-io_destroy.patch

* Wed May 23 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.2.3-2m)
- add workaround support for glibc-2.6

* Wed Feb 14 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.2.3-1m)
- sync with fc-devel (valgrind-3_2_3-2)	
--* Tue Feb 13 2007 Jakub Jelinek <jakub@redhat.com> 3.2.3-2
--- fix valgrind.pc again
--* Tue Feb 13 2007 Jakub Jelinek <jakub@redhat.com> 3.2.3-1
--- update to 3.2.3

* Fri Nov 10 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.2.1-4m)
- sync with fc-devel (valgrind-3.2.1-7)
-* Wed Nov  8 2006 Jakub Jelinek <jakub@redhat.com> 3.2.1-7
-- some cachegrind improvements (Ulrich Drepper)

* Wed Nov  8 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.2.1-3m)
- sync with fc-devel (valgrind-3.2.1-6)
-* Mon Nov  6 2006 Jakub Jelinek <jakub@redhat.com> 3.2.1-6
-- fix valgrind.pc (#213149)
-- handle Intel Core2 cache sizes in cachegrind (Ulrich Drepper)

* Thu Oct 26 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.2.1-2m)
- sync with fc-devel (valgrind-3.2.1-5)
-* Wed Oct 25 2006 Jakub Jelinek <jakub@redhat.com> 3.2.1-5
-- fix valgrind on ppc/ppc64 where PAGESIZE is 64K (#211598)

* Sat Oct 14 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.2.1-1m)
- update to 3.2.1

* Sun Jul 16 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.1.0-2m)
- enable x86_64

* Sun Dec 11 2005 Koichi NARITA <pulsar@sea.plala.or.jp>
- (3.1.0-1m)
- update to 3.1.0

* Sat Nov  6 2004 TAKAHASHI Tamotsu <tamo>
- (2.2.0-1m)
- new stable version

* Sat Mar 27 2004 Toru Hoshina <t@momonga-linux.org>
- (2.1.0-2m)
- revised spec for rpm 4.2.

* Fri Dec 26 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.1.0-1m)
- initial import to Momonga
